#!/bin/sh

# EvoMaintenance script
# install packages postgresql-client and sudo (Debian)
# or port postgresql-client (*BSD)

# version 0.2
# Copyright 2007-2008 Gregory Colpart <reg@evolix.fr>, Evolix <info@evolix.fr>

test -f /etc/evomaintenance.cf && . /etc/evomaintenance.cf

[ $HOSTNAME ] || HOSTNAME=`hostname`
[ $EVOMAINTMAIL ] || EVOMAINTMAIL=evomaintenance-$(echo $HOSTNAME | cut -d- -f1)@$REALM

PATH=$PATH:/usr/sbin
SENDMAIL=$(which sendmail)
# get ipaddress
IP=`LC_ALL=C who -m | grep $SUDO_USER | head -1 | tr -s ' ' | cut -d" " -f6 | sed -e "s/^(// ; s/)$//"`

# get begin_date
BEGIN_YEAR=`date "+%Y"`
BEGIN_DATE=`LC_ALL=C who -m | grep $SUDO_USER | head -1 | tr -s ' ' | cut -d" " -f3,4,5`

# end_date
#now()

# details
echo "Please, enter details about your maintenance"
read TEXTE

if [ "$TEXTE" = "" ]; then
    echo "no value..."
    exit 1
fi

# SQL
TEXTE=`echo "$TEXTE" | sed "s/'/\\\\\\'/g ; s@/@\\\\\/@g ; s@\\&@et@g"`

# recapitulatif
echo "hostname = $HOSTNAME"
echo "user = $SUDO_USER"
echo "IP = $IP"
echo "begin date = $BEGIN_YEAR $BEGIN_DATE"
echo "details = $TEXTE"

echo "To cancel, [Ctrl+C] else press [Enter]"
read enter

# git stuff
if (test -x /usr/bin/git); then
    cd /etc/
    git add .
    GIT_COMMIT=$(git commit -a -m "$TEXTE" --author="$SUDO_USER <$SUDO_USER@evolix.net>")
fi

echo "
INSERT INTO evomaint(hostname,userid,ipaddress,begin_date,end_date,details)
VALUES ('$HOSTNAME','$SUDO_USER','$IP','$BEGIN_YEAR $BEGIN_DATE',now(),'$TEXTE') " | \
psql $PGDB $PGTABLE -h $PGHOST

cat /usr/share/scripts/evomaintenance.tpl | \
    sed -e "s/__TO__/$EVOMAINTMAIL/ ; s/__HOSTNAME__/$HOSTNAME/ ; s/__USER__/$SUDO_USER/ ; s/__BEGIN_DATE__/$BEGIN_YEAR $BEGIN_DATE/ ; s/__TEXTE__/$TEXTE/ ; s/__IP__/$IP/ ; s/__FULLFROM__/$FULLFROM/ ; s/__FROM__/$FROM/ ; s/__URGENCYFROM__/$URGENCYFROM/ ; s/__URGENCYTEL__/$URGENCYTEL/"| \
        $SENDMAIL -oi -t -f $FROM

